<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="参会人员" prop="ryxx">
        <el-input
          v-model="queryParams.ryxx"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="参会地点" prop="chdd">
        <el-input
          v-model="queryParams.chdd"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="参加时间" prop="cjsj2">
        <el-date-picker
          v-model="queryParams.cjsj2"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
        >导出</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" border :data="hyjlList" @selection-change="handleSelectionChange">
      <el-table-column label="单位" align="center" prop="dwmc" />
      <el-table-column label="参会人员" align="center" prop="ryxx" />
      <el-table-column label="参会地点" align="center" prop="chdd" />
      <el-table-column label="参会时间" align="center" prop="cjsj" />
      <el-table-column label="是否请假" align="center" prop="sfqj" />
      <el-table-column label="请假原因" align="center" show-overflow-tooltip prop="qjyy" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改会议记录对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="${comment}" prop="dwid">
          <el-input v-model="form.dwid" placeholder="请输入${comment}" />
        </el-form-item>
        <el-form-item label="${comment}" prop="ryxx">
          <el-input v-model="form.ryxx" placeholder="请输入${comment}" />
        </el-form-item>
        <el-form-item label="${comment}" prop="chdd">
          <el-input v-model="form.chdd" placeholder="请输入${comment}" />
        </el-form-item>
        <el-form-item label="${comment}" prop="sfqj">
          <el-input v-model="form.sfqj" placeholder="请输入${comment}" />
        </el-form-item>
        <el-form-item label="${comment}" prop="qjyy">
          <el-input v-model="form.qjyy" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="${comment}" prop="bz">
          <el-input v-model="form.bz" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listHyjl, getHyjl, delHyjl, addHyjl, updateHyjl } from "@/api/hy/hyjl";

export default {
  name: "Hyjl",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 会议记录表格数据
      hyjlList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        dwid: null,
        ryxx: null,
        chdd: null,
        sfqj: null,
        qjyy: null,
        bz: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询会议记录列表 */
    getList() {
      this.loading = true;
      listHyjl(this.queryParams).then(response => {
        this.hyjlList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        dwid: null,
        ryxx: null,
        chdd: null,
        sfqj: null,
        qjyy: null,
        bz: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加会议记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getHyjl(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改会议记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateHyjl(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addHyjl(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除会议记录编号为"' + ids + '"的数据项？').then(function() {
        return delHyjl(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/hyjl/export', {
        ...this.queryParams
      }, `hyjl_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
